//+------------------------------------------------------------------+
//|                                                        |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property  copyright "Dserg"
#property  link      ""

//---- indicator settings
#property  indicator_chart_window
#property  indicator_buffers 5
#property indicator_color1 SlateGray
#property indicator_color5 DarkKhaki
#property indicator_color4 DarkKhaki
#property indicator_color2 DeepSkyBlue
#property indicator_color3 Tomato
#property indicator_width1 3
#property indicator_width2 3
#property indicator_width3 3
#property indicator_width4 1
#property indicator_style4 STYLE_DOT
#property indicator_style5 STYLE_DOT

//---- buffers
//support
double ChannelUp[];
double ChannelDn[];

double Trend_s[];
double TrendUp_s[];
double TrendDn_s[];
double Volatility[];

//slow
double coeff_s; 
extern double coeff0_f = 0.1;
extern double coeff0_s = 0.3;


int Length1 = 5;   //   
extern int Length1_s = 200;   //   
extern int Length1_f = 1;   //   
int Smooth_Mode1 = 6;   //   1  0 - JJMA, 1 - JurX,        
                 // 2 - ParMA, 3 - LRMA, 4 - T3, 5 - SMA, 6 - EMA, 7 - SSMA, 8 - LWMA
//slow
extern double minMA_s_s = 1.0;
extern double minMA_s_f = 1.0;
double minMA_s = 1.0;
extern double Sens_s = 0.5;
extern int volF = 1;
extern double volP = 2.0;
static int nl_s,nh_s;
static bool calcFlag;

double dev = 1.5;
double dev0 = 0.33;
extern bool drawChannels = false;
//----    +-------------------------------------------------+
int Phase1  = 100; // ,    -100 ... +100, 
                                       //    ;
int Smooth_Mode2 = 0;   //   2  0 - JJMA, 1 - JurX,        
                 // 2 - ParMA, 3 - LRMA, 4 - T3, 5 - SMA, 6 - EMA, 7 - SSMA, 8 - LWMA
int Length2 = 1;   //   
int Phase2  = 100; // ,    -100 ... +100, 
                                       //    ;
int Step = 10; // ,       
int Shift  = 0;   // c     
int Input_Price_Customs = 0; /*  ,     
 (0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 
6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW, 
11-Heiken Ashi Low, 12-Heiken Ashi High, 13-Heiken Ashi Open, 14-Heiken Ashi Close.) */
//---- +------------------------------------------------------------------------------+

int Nstat=3000;
extern datetime D0=D'01.02.2011';
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- 3additional buffers are used for counting.
   
//---- drawing settings
   IndicatorBuffers(6);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3, ChannelUp);      
   SetIndexLabel(3, "ChannelUP");

   SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(4, ChannelDn);      
   SetIndexLabel(4, "ChannelDn");
   
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0, Trend_s);      
   SetIndexLabel(0, "Trend Slow");
   
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1, TrendUp_s);      
   SetIndexLabel(1, "TrendUp Slow");
   
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2, TrendDn_s);      
   SetIndexLabel(2, "TrendDn Slow");

   SetIndexBuffer(5, Volatility);      

   SetIndexEmptyValue(0,0);
   SetIndexEmptyValue(1,0);
   SetIndexEmptyValue(2,0);
   SetIndexEmptyValue(3,0);
   SetIndexEmptyValue(4,0);
   
   calcFlag=false;
   Comment("calculating..");
   return(0);
  }

int deinit ()
  {
      Comment("");  
  }
int start()

  {

      if (IndicatorCounted() < 0) return(-1); 
      
      //  
      Nstat = iBarShift(NULL,0,D0);
      if (Nstat>Bars-10) Nstat -=11;
      
      int loopbegin;
      loopbegin = Nstat;
      
      //fast
      double Brick, Up0, Dn0, BricksUp, BricksDn, lastB, lastS, Profit,K,norm;
      int i;
      static int dir = 0;
      static double h0,l0;
      
      //slow
      double Brick_s, Up0_s, Dn0_s, BricksUp_s, BricksDn_s, lastB_s, lastS_s, Profit_s,K_s,norm_s;
      static int dir_s = 0;
      static double h0_s,l0_s;
      
      
      //--------------------------------------------------
      // Slow
      //--------------------------------------------------
      // 
      if (Close[Nstat+10]<=Close[Nstat+1]) {
         l0_s=Close[Nstat+10];
         h0_s=Close[Nstat+1];
         dir_s=1;
         nl_s=Nstat+10;
         nh_s=Nstat+1;
      }
      if (Close[Nstat+10]>Close[Nstat+1]) {
         l0_s=Close[Nstat+1];
         h0_s=Close[Nstat+10];
         dir_s=-1;
         nl_s=Nstat+1;
         nh_s=Nstat+10;
      }
      //  
      int loopbegin1;
      if (calcFlag) {
         loopbegin1 = MathMin(IndicatorCounted() + 1, loopbegin);
      } else {
         loopbegin1 = loopbegin;
         calcFlag = true;
         Comment("done initial");
      }
      //MA  ..
      for(i = loopbegin1; i >= 0; i--) {
         Volatility[i] = iCustom(NULL,0,"_MasterSlave",1,9*volF,11*volF,0,5*volF,0,i+1);
         Trend_s[i] = iCustom(NULL,0,"X2DigMA",Smooth_Mode1,Length1,Phase1,Smooth_Mode2,Length2,Phase2,Step,Shift,Input_Price_Customs,0,i+1);      
      }
      //
      for(i = loopbegin; i >= 0; i--) {
         
         Step = Sens_s*iATR(NULL,0,Nstat,0)/Point;
         Length1=Length1_s+MathPow(Volatility[i],volP)*(Length1_f-Length1_s);
         
         // 
         //   
         //   buy
         if (dir_s>0&&i<Nstat&&Trend_s[i]>0) {
           // coeff
           coeff_s=coeff0_s+MathPow(Volatility[i],volP)*(coeff0_f-coeff0_s);
           minMA_s=minMA_s_s+MathPow(Volatility[i],volP)*(minMA_s_f-minMA_s_s);

           double rev0_s=h0_s*(1-coeff_s)+l0_s*coeff_s-minMA_s*Point*Step; // 
           if (Trend_s[i]<rev0_s) { //    coeff - 
              dir_s = -1;
              l0_s = Trend_s[i];
              nl_s=i;
           }
           if (Trend_s[i]>h0_s) { // 
              h0_s=Trend_s[i];
              nh_s=i;
           }
         }
         //   
         if (dir_s<0&&i<Nstat&&Trend_s[i]>0) { //   sell
           // coeff
           coeff_s=coeff0_s+MathPow(Volatility[i],volP)*(coeff0_f-coeff0_s);
           minMA_s=minMA_s_s+MathPow(Volatility[i],volP)*(minMA_s_f-minMA_s_s);

           double rev1_s=l0_s*(1-coeff_s)+h0_s*coeff_s + minMA_s*Point*Step; // 
           if (Trend_s[i]>rev1_s) { //    coeff - 
              dir_s = 1;
              h0_s = Trend_s[i];
              nh_s=i;
           }
           if (Trend_s[i]<l0_s) { // 
              l0_s=Trend_s[i];
              nl_s=i;
           }
         }
         // 
         if (dir_s>0) {       
            TrendUp_s[i]=Trend_s[i];
            TrendDn_s[i]=0;
         } else {
            TrendDn_s[i]=Trend_s[i];
            TrendUp_s[i]=0;
         }

         // 
         if (drawChannels) {
            //
            double ch0 = iStdDev(NULL,0,Length1,0,MODE_SMA,PRICE_CLOSE,i+1);
            if (dir_s>0) {       
               ChannelUp[i] = Trend_s[i] + dev0*dev*ch0;
               ChannelDn[i] = Trend_s[i] - (1.0-dev0)*dev*ch0;
            } else {
               ChannelUp[i] = Trend_s[i] + (1.0-dev0)*dev*ch0;
               ChannelDn[i] = Trend_s[i] - dev*dev0*ch0;
            }
         }
      }

      return(0);
  }
//+------------------------------------------------------------------+



